#!/usr/bin/env python

"""
  Author:  Yeison Cardona --<yeison.eng@gmail.com>
  Purpose:
  Created: 22/10/15
"""

from bitcoinapi import Wallet

TOKEN = "eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJ1c2VybmFtZSI6InllaXNvbiIsImV4cCI6MTQ0NTUzODU2MCwiZW1haWwiOiJ5ZWlzb24uZW5nQGdtYWlsLmNvbSIsInVzZXJfaWQiOjF9.jOfwV6MYV3LXPFb_rqcySpKm-9219jueeA2sOEXqrMg"
api_wallet = Wallet(TOKEN)

# Create a Wallet

# First all you need a keypair (public and private), you can get one for test with:
keys = api_wallet.newhdwallet(entropyphrase="JJAG")
print("Public Key: {pubkey}".format(**keys))
print("Private Key: {privkey}".format(**keys))
print("WIF Key: {privkey_wif}".format(**keys))
# NOTE: use this method for test only, don not generate privkeys here!!


# After this we only need a public key!!
# for example:
PUBKEY = "tpubD6NzVbkrYhZ4XHJBqhmxjN6xwKAV6qrcnJrghjcYiY25EefV9TkEtsVqKqs63SbVgSESPyUeDdLRRmkE9g2fgJBigMAq63NX6yMK8Gwz6pm"


# Specification: Wallet structure
# An HDW is organized as several 'accounts'. Accounts are numbered, the default account being number 0.
# Clients are not required to support more than one account - if not, they only use the default account.

# Each account is composed of two keypair chains: an internal and an external one. The external keychain
# is used to generate new public addresses, while the internal keychain is used for all other operations
# (change addresses, generation addresses, ..., anything that doesn't need to be communicated).
# Clients that do not support separate keychains for these should use the external one for everything.


# We can generate accounts with one index, in this case 0
account_0 = api_wallet.HDWgetaccount(pubkey=PUBKEY, account=0)
print("Account 0")
print("\tpubkey (base58): {base58}".format(**account_0))
print("\tpubkey (hex): {hex}".format(**account_0))


# But really we don not need before step for acces to chains, we just need the in dex (0)
# if we want the chain 0
chain_0 = api_wallet.HDWgetchain(pubkey=PUBKEY, account=0, chain=0)
print("Chain 0")
print("\tinternal: {internal}".format(**chain_0))
print("\texternal: {external}".format(**chain_0))


# Remember that chains are used for generate addresses
# so if we want generate the address 1 for chain 0, and account 0
address_0 = api_wallet.HDWgetaddressext(pubkey=PUBKEY, account=0, chain=0, k=0)  #HDWgetaddressext is for public addresses
address_0_change = api_wallet.HDWgetaddressint(pubkey=PUBKEY, account=0, chain=0, k=0)  #HDWgetaddressint is for other cases, like change
print(address_0, address_0_change)



# If we want generate the first N addresses, N=100
print("Take a while...")
address_N = api_wallet.HDWgetaddressext(pubkey=PUBKEY, account=0, chain=0, k="[0:100]")
for k in address_N:
    print("{}: {}".format(k, address_N[k]))



# api_wallet = Wallet(TOKEN)


# # keys = api_wallet.newhdwallet(entropyphrase="JJAG")
# # print(keys)
# # pubkey = keys["pubkey"]

# privkey = 'tprv8ZgxMBicQKsPdpGPx47NKxSrNHeYwWfiD1FuRDaFJGDgQAQiX4veiNsy9iVuj2M7BkY4k66RFRWS57vnznQmY8UBBziaA3q3gzGnSmZoeeq'
# privkey_wif = '92wrmyaTZm6sVk6J69bHz6u1kkd2hBVd39mhZqJLGNf8bqnUHZh'
# pubkey = 'tpubD6NzVbkrYhZ4XHJBqhmxjN6xwKAV6qrcnJrghjcYiY25EefV9TkEtsVqKqs63SbVgSESPyUeDdLRRmkE9g2fgJBigMAq63NX6yMK8Gwz6pm'


# node = api_wallet.getnode(pubkey=pubkey, k=5, path="1/2/3/4")
# print(node)


# address = api_wallet.getaddress(pubkey=pubkey, k=6, path="1/2")
# print(address)


# node2 = api_wallet.getnode(pubkey=pubkey, k=3, path="m/1/4/16")
# print(node2)
# pubkey2 = node2["base58"]


# address2 = api_wallet.getaddress(pubkey=pubkey2, k=5)
# address3 = api_wallet.getaddress(pubkey=pubkey, k=5, path="m/1/4/16/3")
# print(address2)
# print(address3)
# assert address2==address3, "MAL!!"



# pubkey = 'tpubD6NzVbkrYhZ4XHJBqhmxjN6xwKAV6qrcnJrghjcYiY25EefV9TkEtsVqKqs63SbVgSESPyUeDdLRRmkE9g2fgJBigMAq63NX6yMK8Gwz6pm'

# WALLET_INDEX = 5
# wallet = api_wallet.HDWgetwallet(pubkey=pubkey, wallet=WALLET_INDEX)


# # chain = api_wallet.HDWgetchain(pubkey=pubkey, wallet=WALLET_INDEX, chain=45)



# address_1 = api_wallet.HDWgetaddressext(pubkey=pubkey, wallet=WALLET_INDEX, chain=45, k=0)
# print(address_1)




# # "HDWgetaddressext": "http://localhost:8888/api/bip32/HDWgetaddressext/",
# # "HDWgetaddressint": "http://localhost:8888/api/bip32/HDWgetaddressint/",
# # "HDWgetaddress": "http://localhost:8888/api/bip32/HDWgetaddress/",
# # "HDWgetwallet": "http://localhost:8888/api/bip32/HDWgetwallet/",
# # "HDWgetchain": "http://localhost:8888/api/bip32/HDWgetchain/",
# # # "newhdwallet": "http://localhost:8888/api/bip32/newhdwallet/",
# # # "getaddress": "http://localhost:8888/api/bip32/getaddress/",
# # # "getnode": "http://localhost:8888/api/bip32/getnode/"